#include <tricks.h>

static short costab[1000][4];

void pl_init();
void pl_deinit();
void pl_loop();

void pl_init()
{
   for(int i=0;i<1000;i++)
      costab[i][0]=(cos(2*PI*float(i)/150)*32*256)+32*256;

   for(i=0;i<1000;i++ )
      costab[i][1]=(cos(2*PI*float(i)/250)*32*256)+32*256;

   for(i=0;i<1000;i++)
      costab[i][2]=(cos(2*PI*float(i)/200)*32*256)+32*256;

   for(i=0;i<1000;i++)
      costab[i][3]=(cos(2*PI*float(i)/300)*32*256)+32*255;

   for( i=0; i<64; i++)
   {
      pal[(i*3)]=i;
      pal[(i*3)+1]=63-i;
      pal[(i*3)+2]=i;

      pal[((i+64)*3)]=63-i;
      pal[((i+64)*3)+1]=i;
      pal[((i+64)*3)+2]=63;

      pal[((i+128)*3)]=0;
      pal[((i+128)*3)+1]=63-i;
      pal[((i+128)*3)+2]=63;

      pal[((i+192)*3)]=0;
      pal[((i+192)*3)+1]=i;
      pal[((i+192)*3)+2]=63-i;
   }
   pal[0]=0;
   pal[1]=0;
   pal[2]=0;
}

void pl_loop()
{
   static int y1 = 0;
   static int y2 = 0;
   static int x1 = 0;
   static int x2 = 0;
   static int spin = 0;

   y1++;
   y2-=2;
   x1+=2;
   x2--;

   if(y1>300)y1-=300;
   if(y2<0)  y2+=500;
   if(x1>400)x1-=400;
   if(x2<0)  x2+=600;

   int spin1=spin++;
   byte *b=(byte*)buf;

   int y=200;
   do{
      short tmp=costab[y+y1][0]+costab[y+y2][1];
      int spin2=spin1++;
      int x=320;
      do{
         *b++=((((tmp+costab[x+x1][2]+costab[x+x2][3])>>8)+spin2)&0xfe)+1;
      }while(--x);
   }while(--y);
}

