#include <tricks.h>

static byte ba_bumpmap[64000];
static byte ba_envmap[64000];
byte ba_pal[768];
static short ba_costab[1000][4];

void ba_loop()
{  
   // calculate bump+envmap -> buffer
  
   byte *src=ba_bumpmap+320*10;
   int *dst=(int*)(buf+320*10);

   for(int i=10;i<190;i++){
      for(int j=5;j<317;j++){
         int tmp=ba_envmap[*src-src[1]+j+(*src-src[320]+i)*320];
         src++;
         j++;
         tmp+=(ba_envmap[*src-src[1]+j+(*src-src[320]+i)*320]&0xff)<<8;
         src++;
         j++;
         tmp+=(ba_envmap[*src-src[1]+j+(*src-src[320]+i)*320]&0xff)<<16;
         src++;
         j++;
         tmp+=(ba_envmap[*src-src[1]+j+(*src-src[320]+i)*320]&0xff)<<24;
         src++;
         *dst++=tmp;
      }
      src+=8;
      dst+=2;
   }

   // calculate new bumpmap...

   static int y1 = 0;
   static int y2 = 0;
   static int x1 = 0;
   static int x2 = 0;

   y1++;
   y2--;
   x1++;
   x2--;

   if(y1>100)y1-=100;
   if(y2<0)  y2+=200;
   if(x1>300)x1-=300;
   if(x2<0)  x2+=400;

   int *buf=(int*)ba_bumpmap;

   int y=200;
   do{
      short tmp=ba_costab[y+y1][0]+ba_costab[y+y2][2];
      int x=320;
      do{
         int temp=(tmp+ba_costab[x+x1][1]+ba_costab[x+x2][3])>>8;
         x--;
         temp+=(tmp+ba_costab[x+x1][1]+ba_costab[x+x2][3])&0xff00;
         x--;
         temp+=((tmp+ba_costab[x+x1][1]+ba_costab[x+x2][3])&0xff00)<<8;
         x--;
         temp+=((tmp+ba_costab[x+x1][1]+ba_costab[x+x2][3])&0xff00)<<16;
         *buf++=temp;
      }while(--x);
   }while(--y);
}

void ba_init()
{
   load("data\\bitaddic.raw",ba_envmap,64000);
   loadpal("data\\bitaddic.pal",ba_pal);

   for(int i=0;i<1000;i++)
      ba_costab[i][0]=(cos(2*PI*float(i)/50)*32*256)+32*256;

   for(i=0;i<1000;i++ )
      ba_costab[i][1]=(cos(2*PI*float(i)/100)*32*256)+32*256;

   for(i=0;i<1000;i++)
      ba_costab[i][2]=(cos(2*PI*float(i)/150)*32*256)+32*256;

   for(i=0;i<1000;i++)
      ba_costab[i][3]=(cos(2*PI*float(i)/200)*32*256)+32*256;
}

