#include <vesa20.h>
#include <tricks.h>

byte *dragon;
byte *fox;
byte dragonpal[768];
byte foxpal[768];

void showdragon()
{
  dragon=new byte[320*450];
  load("data\\dragon.raw",dragon,320*450);
  loadpal("data\\dragon.pal",dragonpal);
  SetMCGA();
  WaitRetrace();
  for(int i=0;i<256;i++)
    Pal(i,dragonpal[i*3],dragonpal[i*3+1],dragonpal[i*3+2]);

  for(int off=450-320;off>=30;off--){
    fastMemCopy(dragon+off*320,vga,16000);
    WaitRetrace();
  }
}

void deinitdragon()
{
  delete[] dragon;
}

void showfox()
{
  fox=new byte[320*550];
  load("data\\fox.raw",fox,320*550);
  loadpal("data\\fox.pal",foxpal);
  SetMCGA();
  WaitRetrace();
  for(int i=0;i<256;i++)
    Pal(i,foxpal[i*3],foxpal[i*3+1],foxpal[i*3+2]);

  for(int off=550-320;off>=0;off--){
    fastMemCopy(fox+off*320,vga,16000);
    WaitRetrace();
  }
}

void deinitfox()
{
  delete[] fox;
}
